!=====================================================!
!                                                     !
!     This work is distributed under CC_BY_NC_SA      !
!                                                     !
! Created by Ruben M. Cabezon and Domingo Garcia-Senz !
!               ruben.cabezon@unibas.ch               !
!               domingo.garcia@upc.edu                !
!                                                     !
!                        (2017)                       !
!                                                     !
!=====================================================!
!                                                     !
!                  SPHYNX: eosmod.f90                 !
!                                                     !
! Calls different EOS.                                !
!=====================================================!

      SUBROUTINE eostot

      USE parameters

      IMPLICIT NONE
      DOUBLE PRECISION, DIMENSION(nmax):: ueos

      call profile(0)
      if(flags)print *,'Calculating EOS'

      p=0.d0
      c=0.d0
      pro=0.d0
      dpdt=0.d0
      cv=0.d0
      dudv=0.d0
      ueos=0.d0

      if (eos.eq.1) then

         call eosid_t(ueos)
         !input: temp,promro,mui
         !This populates p,u,c,cv,dpdt,dpdr

      else if (eos.eq.2) then

         call eosid_u
         !input: promro,u,gamma
         !This populates p,temp,c,cv,dpdt

      else

         write(*,*) 'Not defined EOS!'
         stop

      endif
      
      cmax=maxval(c)
      if(l.eq.iterini.and.inienergy)u=ueos

      pro(:)=p(:)/(sumkx(:))**2

      call profile(1)

      RETURN
      END SUBROUTINE eostot
